
#include "HAL_conf.h"

void uart_printf( const char * ctrl1, ...);
/********************************************************************************************************
**Ϣ UartInit(UART_TypeDef* UARTx)                      
** ʼ
** UART_TypeDef* UARTx ѡUART1UART2UART3
** 
********************************************************************************************************/

void UartInit(UART_TypeDef* UARTx,u32 baud)
{
    UART_InitTypeDef       UART_InitStructure;  
	GPIO_InitTypeDef  GPIO_InitStructure;   
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);
	
	GPIO_PinAFConfig(GPIOA, GPIO_Pin_9 | GPIO_Pin_10, GPIO_AF_UART_1); //PA9PA10Ϊ1	

	UART_InitStructure.UART_BaudRate = baud; //
  UART_InitStructure.UART_WordLength = UART_WordLength_8b;//λ
  UART_InitStructure.UART_StopBits = UART_StopBits_1;//ֹͣλ
  UART_InitStructure.UART_Parity = UART_Parity_No ;
  UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;//ģʽ
  UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None; 	
	UART_Init(UARTx, &UART_InitStructure);
	UART_Cmd(UARTx, ENABLE);  //UART ģʹ

  UART_ClearITPendingBit(UARTx, 0xff); 
	
	//עʼ˳򿪣ַӡ
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_9;   //uart1_tx  pa9
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; // ⸴
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_10;  //uart1_rx  pa10
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; //   
  GPIO_Init(GPIOA, &GPIO_InitStructure);
}

/********************************************************************************************************
**Ϣ uart_send(UART_TypeDef* UARTx,char c)                    
** ڷֽ
** UART_TypeDef* UARTx ѡUART1UART2UART3
** char c ,ڷ͵ֽ
** 
********************************************************************************************************/

void uart_send(UART_TypeDef* UARTx,char c)
{
	unsigned int i  = 20000;
 	
	UART_SendData(UARTx,(uint16_t)c);  
	
	while(1)
	{
        
        if(UART_GetFlagStatus(UARTx, UART_IT_TXIEN))
        {
            //UART_GetITStatus(UARTx, UART_IT_TXIEN);
            break;
        }
        if(i-- == 0)
        {
            break;
        }
	}
}

/********************************************************************************************************
**Ϣ unsigned char inbyte(UART_TypeDef* UARTx)                
** ڽպ
** UART_TypeDef* UARTx ѡUART1UART2UART3
** unsigned char ڽշصֽ
********************************************************************************************************/

unsigned char inbyte(UART_TypeDef* UARTx)
{
	unsigned char temp;

	while(1)
	{
		if(UART_GetITStatus(UARTx, UART_IT_RXIEN))
		{
			UART_ClearITPendingBit(UARTx, UART_IT_RXIEN);  //жλ
			break;
		}
    }
	temp = (uint8_t)UART_ReceiveData(UARTx); 
	return temp;
}
unsigned char recvbyte(UART_TypeDef* UARTx,unsigned char *ucbyte)
{
	unsigned char temp=0;


    if(UART_GetITStatus(UARTx, UART_IT_RXIEN))
    {
        UART_ClearITPendingBit(UARTx, UART_IT_RXIEN);  //жλ
        *ucbyte = (uint8_t)UART_ReceiveData(UARTx); 
        temp = 1;
    } 
	
	return temp;
}

/********************************************************************************************************
**Ϣ void outbyte(char c)               
** ڷͺԣͨԳն˻ߴӡ
** char c ڷ͵ֽ
** 
********************************************************************************************************/

void outbyte(char c)
{
	uart_send(UART1,c); // UART2UART3,úĵһ
}
